Public Member Functions | Static Public Attributes | Private Attributes

# GameDifficultyWindow Class Reference

Inheritance diagram for GameDifficultyWindow:

## Public Member Functions
| GameDifficultyWindow (const WindowDesc *desc)
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
## Static Public Attributes
static const uint | GAME_DIFFICULTY_NUM = 18
| The number of difficulty settings.
static const uint | WIDGETS_PER_DIFFICULTY = 3
| The number of widgets per difficulty setting.
## Private Attributes
GameSettings | opt_mod_temp

## Detailed Description

Definition at line 688 of file settings_gui.cpp.

## Member Function Documentation

virtual void GameDifficultyWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 751 of file settings_gui.cpp.

References _network_server, _networking, CMD_CHANGE_SETTING, SaveLoad::conv, SettingDesc::desc, DifficultySettings::diff_level, GameSettings::difficulty, DoCommandP(), GAME_DIFFICULTY_NUM, GetGameSettings(), AI::GetInfoList(), GetSettingFromName(), GetVariableAddress(), SettingDescBase::interval, INVALID_STRING_ID, Window::InvalidateData(), Window::LowerWidget(), max(), SettingDescBase::max, DifficultySettings::max_no_competitors, SettingDescBase::min, min(), Window::RaiseWidget(), ReadValue(), SettingDesc::save, ShowErrorMessage(), ShowHighscoreTable(), WID_GD_ACCEPT, WID_GD_CANCEL, WID_GD_HIGHSCORE, WID_GD_LVL_CUSTOM, WID_GD_LVL_EASY, WID_GD_LVL_HARD, WID_GD_LVL_MEDIUM, WID_GD_OPTIONS_START, WL_CRITICAL, and WriteValue().

virtual void GameDifficultyWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.

See also:
  GameOptionsInvalidationData

Parameters:

  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 840 of file settings_gui.cpp.

References SaveLoad::conv, SettingDesc::desc, DifficultySettings::diff_level, GameSettings::difficulty, SettingDescBase::flags, GAME_DIFFICULTY_NUM, GetGameSettings(), GetSettingFromName(), GetVariableAddress(), GOID_DIFFICULTY_CHANGED, Window::LowerWidget(), SettingDescBase::max, SettingDescBase::min, ReadValue(), SettingDesc::save, Window::SetWidgetDisabledState(), SGF_SCENEDIT_TOO, SlIsObjectCurrentlyValid(), SaveLoad::version_from, SaveLoad::version_to, WID_GD_LVL_EASY, and WID_GD_OPTIONS_START.

virtual void GameDifficultyWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 718 of file settings_gui.cpp.

References SaveLoad::conv, SettingDesc::desc, GetSettingFromName(), GetVariableAddress(), ReadValue(), SettingDesc::save, SetDParam(), and SettingDescBase::val_str.

virtual void GameDifficultyWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 731 of file settings_gui.cpp.

References SettingDesc::desc, GetSettingFromName(), GetStringBoundingBox(), SettingDescBase::interval, SettingDescBase::max, maxdim(), SettingDescBase::min, SetDParam(), and SettingDescBase::val_str.

The documentation for this class was generated from the following file:

- src/settings_gui.cpp